import 'package:flutter_custom_toolbox/flutter_toolbox.dart';

import 'package:plotter/config/default_activity_settings.dart';

class ActivitySettings {
  final String plotterType;

  ActivitySettings({
    required this.plotterType,
  });

  static String getPlotterTypeValueFromUnsafe(String plotterType) {
    if (DefaultActivitySettings.allowedPlotterTypeValues.contains(plotterType)) {
      return plotterType;
    }

    return DefaultActivitySettings.defaultPlotterTypeValue;
  }

  factory ActivitySettings.createDefault() {
    return ActivitySettings(
      plotterType: DefaultActivitySettings.defaultPlotterTypeValue,
    );
  }

  void dump() {
    printlog('$ActivitySettings:');
    printlog('  ${DefaultActivitySettings.parameterCodePlotterType}: $plotterType');
    printlog('');
  }

  @override
  String toString() {
    return '$ActivitySettings(${toJson()})';
  }

  Map<String, dynamic>? toJson() {
    return <String, dynamic>{
      DefaultActivitySettings.parameterCodePlotterType: plotterType,
    };
  }
}
